<script setup>
import { ref } from 'vue';
// Importamos el componente ButtonCounter para poder usarlo desde este otro componente
import ButtonCounter from './components/ButtonCounter.vue';
import BlogPost from './components/BlogPost.vue';
import PaginatePost from './components/PaginatePost.vue';

//creamos un arreglo para simular que estamos recibiendo datos de una API,
//en este caso los posts
const posts = ref([]);

//creamos una variable reactiva para guardar el título del post favorito
const favorito = ref('');

// creamos variables para manejar la paginación
//vamos a controlar cual será el post inicial y final de la primer
//página, y cuantos post por página mostraremos y esto
//lo usaremos para reemplazar en el slice
//de nuestro v-for que muestra los posts
const postXPage = 10;
const inicio = ref(0);
const fin = ref(postXPage);

//creamos una función para cambiar el valor de la variable favorito,
//esta será enviada como método personalizado al componente hijo BlogPost
const cambiarFavorito = (title) => {
	favorito.value = title;
};

//consumimos la API de jsonplaceholder, convertimos la respuesta
//a json y finalmente guardamos el valor de la respuesta al valor de nuestra variable posts,
//lo cual pintará los posts de esa API en nuestro componente
fetch('https://jsonplaceholder.typicode.com/posts')
	.then((res) => res.json())
	.then((data) => {
		posts.value = data;
	});
</script>

<template>
	<div class="container">
		<h1>App</h1>
		<!-- pintamos nuestra variable favorito -->
		<h2>Mis Posts Favoritos:{{ favorito }}</h2>

		<!-- importamos nuestro componente paginador que creamos -->
		<!-- le enviamos una clase y esta clase es una prop especial de vue, al enviarla
		se aplica esa clase al primer elemento que está dentro de la plantilla del componente,
		en el caso de este componente es un div por tanto podemos enviarla sin problemas y esto aplicará
		esa clase en ese div-->
		<PaginatePost class="mb-2" />

		<!-- Usamos el componente ButtonCounter -->
		<!-- Lo estamos usando 2 veces y notar que cada uno tiene su propio estado interno
     separado del otro -->
		<!-- Podemos usar los componentes usando pascal case o kebab case, como se muestra a continuación -->
		<!-- <ButtonCounter />
		<button-counter /> -->
		<!-- Usamos el componente BlogPost y como recibe una prop title, la enviamos con el valor 
    que queremos que tenga -->
		<!-- enviamos varias props a nuestros elementos -->
		<!-- <BlogPost title="Post 1" :id="1" body="description 1" />
		<BlogPost title="Post 2" :id="2" body="description 2" />
		<BlogPost title="Post 3" :id="3" body="description 3" />
		<BlogPost title="Post 4" :id="4" /> -->
		<!-- vamos a iterar sobre nuestros posts, asignamos la variable post para cada item de posts
    y asignamos las props de nuestro componente usando v-bind para poder usar la variable post que creamos
  en el for -->
		<!-- enviamos como metodo personalizado nuestra función cambiarFavorito, a nuestro componente hijo
  y como valor le asignamos la función del mismo nombre  -->
		<BlogPost
			v-for="post in posts.slice(inicio,fin)"
			class="mb-2"
			:key="post.id"
			:title="post.title"
			:id="post.id"
			:body="post.body"
			@cambiarFavoritoNombre="cambiarFavorito"
			:cambiarFavorito="cambiarFavorito"
		/>
	</div>
</template>

